Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.pool
Interface PoolableObjectFactory

All Known Implementing Classes:
  BasePoolableObjectFactory

    public interface PoolableObjectFactory

An interface defining life-cycle methods for instances to be served by an `ObjectPool`.

By contract, when an `ObjectPool` delegates to a `PoolableObjectFactory`,

1. `makeObject` is called whenever a new instance is needed.
2. `activateObject` is invoked on every instance that has been `passivated` before it is `borrowed` from the pool.
3. `validateObject` is invoked on `activated` instances to make sure they can be `borrowed` from the pool. `validateObject` may also be used to test an instance being `returned` to the pool before it is `passivated`. It will only be invoked on an activated instance.
4. `passivateObject` is invoked on every instance when it is returned to the pool.
5. `destroyObject` is invoked on every instance when it is being "dropped" from the pool (whether due to the response from `validateObject`, or for reasons specific to the pool implementation.) There is no guarantee that the instance being destroyed will be considered active, passive or in a generally consistent state.

`PoolableObjectFactory` must be thread-safe. The only promise an `ObjectPool` makes is that the same instance of an object will not be passed to more than one method of a `PoolableObjectFactory` at a time.

Since:
  Pool 1.0
Version:
  $Revision: 777748 $ $Date: 2009-05-22 17:00:44 -0700 (Fri, 22 May 2009) $
Author:
  Rodney Waldhoff, Sandy McArthur
See Also:
  `ObjectPool`

Method Summary
`void` | `activateObject(Object obj)` Reinitialize an instance to be returned by the pool.
`void` | `destroyObject(Object obj)` Destroys an instance no longer needed by the pool.
`Object` | `makeObject()` Creates an instance that can be served by the pool.
`void` | `passivateObject(Object obj)` Uninitialize an instance to be returned to the idle object pool.
`boolean` | `validateObject(Object obj)` Ensures that the instance is safe to be returned by the pool.

Method Detail

### makeObject

    Object makeObject()
                      throws Exception

  Creates an instance that can be served by the pool. Instances returned from this method should be in the same state as if they had been `activated`. They will not be activated before being served by the pool.

  Returns:
    an instance that can be served by the pool.
  Throws:
    `Exception` - if there is a problem creating a new instance, this will be propagated to the code requesting an object.

### destroyObject

    void destroyObject(Object obj)
                       throws Exception

  Destroys an instance no longer needed by the pool.

  It is important for implementations of this method to be aware that there is no guarantee about what state `obj` will be in and the implementation should be prepared to handle unexpected errors.

  Also, an implementation must take in to consideration that instances lost to the garbage collector may never be destroyed.

  Parameters:
    `obj` - the instance to be destroyed
  Throws:
    `Exception` - should be avoided as it may be swallowed by the pool implementation.
  See Also:
    `validateObject(java.lang.Object)`, `ObjectPool.invalidateObject(java.lang.Object)`

### validateObject

    boolean validateObject(Object obj)

  Ensures that the instance is safe to be returned by the pool. Returns `false` if `obj` should be destroyed.

  Parameters:
    `obj` - the instance to be validated
  Returns:
    `false` if `obj` is not valid and should be dropped from the pool, `true` otherwise.

### activateObject

    void activateObject(Object obj)
                        throws Exception

  Reinitialize an instance to be returned by the pool.

  Parameters:
    `obj` - the instance to be activated
  Throws:
    `Exception` - if there is a problem activating `obj`, this exception may be swallowed by the pool.
  See Also:
    `destroyObject(java.lang.Object)`

### passivateObject

    void passivateObject(Object obj)
                         throws Exception

  Uninitialize an instance to be returned to the idle object pool.

  Parameters:
    `obj` - the instance to be passivated
  Throws:
    `Exception` - if there is a problem passivating `obj`, this exception may be swallowed by the pool.
  See Also:
    `destroyObject(java.lang.Object)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2011 The Apache Software Foundation. All Rights Reserved.